local LCA = LibCombatAlerts
local CA1 = CombatAlerts
local CA2 = CombatAlerts2
local Module = CA_Module:Subclass()

Module.ID = "CA_M_U42"
Module.NAME = CA2.FriendlyModuleName(42, 1478)
Module.AUTHOR = "@code65536"
Module.ZONES = {
	1478, -- Lucent Citadel
}

Module.MONITOR_UNIT_IDS = true

Module.TIMER_ALERTS_LEGACY = {
	[217971] = { -2, 0, false, { 1, 0, 0.6, 0.8 } }, -- Heavy Strike
	[218274] = { -2, 2 }, -- Shear (Count Ryelaz)
	[222605] = { -2, 2 }, -- Shear (Baron Rize)
	[218672] = { -2, 2 }, -- Uppercut
	[218710] = { -2, 2 }, -- Butcher
	[218967] = { -2, 2 }, -- Uppercut
	[219030] = { -2, 2 }, -- Power Bash
	[219139] = { -2, 2 }, -- Smite
	[219420] = { 0, 0, false, { 1, 0, 0.6, 0.8 } }, -- Smite
	[219793] = { -2, 2 }, -- Crushing Shards
	[221863] = { -2, 0, false, { 1, 0, 0.6, 0.8 } }, -- Heavy Attack
	[221881] = { -2, 0, false, { 1, 0, 0.6, 0.8 } }, -- Frenzy
	[222271] = { 0, 0, false, { 1, 0, 0.6, 0.8 } }, -- Heavy Strike
	[222559] = { -2, 0, false, { 1, 0, 0.6, 0.8 } }, -- Batter
}

Module.AOE_ALERTS = {
	-- { alert_duration, exclude_tanks }
	[214675] = { 700, false }, -- Radiance
	[219301] = { 900, false }, -- Radiance (Cavot Agnan)
}

Module.DEFAULT_SETTINGS = {
	raidLeadMode = false,
	mirrorSpawns = true,
	whirlwind = false,
	extraAlerts = true,
	knotNumber = true,
	cooldownPanel = true,
	colorPassage = 0xFF000099,
	colorOverloaded = 0x0099FF99,
	colorBoth = 0xFF00FF99,
	suicidePrevention = true,
}

local STRINGS = {
	-- Extracted
	["8290981-0-121169"] = { default = "Orphic Shattered Shard^N", de = "orphische Splitterscherbe^f", es = "fragmento destrozado órfico^m", fr = "fragment brisé orphique^m", jp = "オーフィックの砕けた欠片^n", ru = "Таинственный осколочник^N", zh = "神秘破裂碎片" },
	["8290981-0-121484"] = { default = "Shardborn Lightweaver^f", de = "Scherbensaat-Lichtweberin^f", es = "tejedora de luz nacida de la esquirla^f", fr = "tisse-lumière Enfant du fragment^f", jp = "シャードボーン・ライトウィーバー^f", ru = "Ткачиха света из клана Детей Осколков^f", zh = "碎晶族织光者" },
	["8290981-0-121485"] = { default = "Gloomy Blackguard^f", de = "düstere Schwarzwache^f", es = "guardia negra lúgubre^f", fr = "garde-obscurité sinistre^m", jp = "薄暗いブラックガード^f", ru = "Сумрачный страж мрака^f", zh = "幽暗黑卫" },
	["8290981-0-121486"] = { default = "Mirrormoor Bone Flayer^n", de = "Spiegelmoor-Knochenschinder^m", es = "despellejador del Páramo Espejado^m", fr = "fouette-os de la Lande miroir^m", jp = "ミラームーアのボーンフレイヤー^n", ru = "Костяной живодер Зеркальной Пустоши^n", zh = "镜泽骷髅剥皮者" },
	["8290981-0-121487"] = { default = "Gloomy Infernium^n", de = "düsteres Infernium^n", es = "infernio lúgubre^m", fr = "Infernium sinistre^m", jp = "薄暗いインファーニウム^n", ru = "Сумрачный пламенник^n", zh = "幽暗死域魔虫" },
	["74865733-0-34170"] = { default = "Claim", de = "Einlösen", es = "Reclamar", fr = "Récupérer", jp = "獲得", ru = "Взять", zh = "获取" },
	["87370069-0-34170"] = { default = "Arcane Knot", de = "arkaner Knoten^m", es = "nudo arcano^m", fr = "nœud arcanique^md", jp = "アルケインの結び目", ru = "Тайный узел", zh = "奥术结" },
	["254784612-0-28"] = { default = "IMMUNE", de = "IMMUN", es = "INMUNE", fr = "IMMUNITÉ", jp = "無効", ru = "НЕВОСПРИИМЧИВОСТЬ", zh = "免疫" },

	-- Custom (Alerts)
	majVuln = { default = LCA.GetAbilityName(LCA.IDS.MAJ_VULN), en = "Major Vuln" },
	newMirrors = { default = LCA.GetAbilityName(217589), de = "Neue Spiegel" },
	noCarrier = { default = "NO CARRIER", de = "KEIN TRÄGER", zh = "没有携带者" },
	toNext = { default = "to next", de = "bis zum Nächsten", zh = "轮到下一个" },

	-- Custom (Settings)
	mirrorSpawns = { default = "Announce second boss mirror spawns", de = "Meldung für neue Spiegel anzeigen", zh = "宣布第二个BOSS镜子生成" },
	extraAlerts = { default = "Enable additional alerts", de = "Zusätzliche Benachrichtigungen anzeigen", zh = "启用附加警报" },
	knotNumber = { default = "Show knot number", de = "Knotennummer anzeigen", zh = "显示奥术结编号" },
	cooldownPanel = { default = "Enable group-wide cooldown panel", de = "Panel zur Anzeige der Cooldowns aktivieren", zh = "启用全团冷却时间面板" },
	suicidePrevention = { default = "Enable Splintered Passage protection", de = "Suizid durch Knoten verhindern", zh = "启用残破通道保护" },
}

local COLOR_L32 = 0xFFFF66FF
local COLOR_D32 = 0xCC3333FF

local Data = {
	-- General
	extraAlertsTooltipIds = { 214237, 214254, 218283, 214678, 213685, 221945, 219165, 219179 },
	refresh = 222903,
	darkness = 214338,
	sunburst = {
		id = 214678,
		damage = 214684,
	},
	aoeCleave = {
		[219050] = true, -- Shield Throw (Jresazzel)
		[219165] = true, -- Piercing Beam
		[221945] = true, -- Shield Throw (Crystal Hollow Sentinel)
	},

	-- Boss 1
	boss1Abilities = {
		-- Abilities unique to the first boss for identification purposes
		[217907] = true, -- Swipe
		[217908] = true, -- Rend
		[217909] = true, -- Slash
		[217910] = true, -- Rend
		[222260] = true, -- Focused Ray
		[222277] = true, -- Twin Jab
		[222278] = true, -- Sting
	},
	boss1DimAlpha = { 0.4, 0.6 },
	boss1Reverse = { "dark", "light" },
	mirrorSide = {
		light = 219329,
		dark = 219330,
	},
	annihilation = {
		[214187] = "dark", -- Brilliant Annihilation
		[214203] = "light", -- Bleak Annihilation
		duration = 12000,
	},
	luster = {
		[214237] = COLOR_L32, -- Brilliant Lusterbeam
		[214254] = COLOR_D32, -- Bleak Lusterbeam
	},
	summons = {
		[218101] = {
			-- Mirrormoor Bone Flayer
			name = LCA.GetLocalizedData(STRINGS["8290981-0-121486"]),
			side = "light",
			color = COLOR_L32,
			tank = false,
		},
		[218105] = {
			-- Gloomy Infernium
			name = LCA.GetLocalizedData(STRINGS["8290981-0-121487"]),
			side = "dark",
			color = COLOR_D32,
			tank = false,
		},
		[218109] = {
			-- Gloomy Blackguard
			name = LCA.GetLocalizedData(STRINGS["8290981-0-121485"]),
			side = "light",
			color = COLOR_L32,
			tank = true,
		},
		[218113] = {
			-- Shardborn Lightweaver
			name = LCA.GetLocalizedData(STRINGS["8290981-0-121484"]),
			side = "dark",
			color = COLOR_D32,
			tank = true,
		},
	},
	shear = {
		[218274] = true,
		[222605] = true,
	},
	meteor = 218283,

	-- Miniboss
	radiance = {
		id = 214085,
		duration = 5000,
		interval = 30000, -- 30s from end to start
	},

	-- Boss 2
	boss2Spawned = false,
	breakout = 217841,
	fateSealer = 214136,
	immunity = {
		light = 219444,
		dark = 219447,
		[219444] = { 217842, COLOR_L32 },
		[219447] = { 217843, COLOR_D32 },
	},
	jump = {
		id = 214383,
		escape = {
			[217987] = -1, -- Defeated
			[219545] = -2, -- Execute
		},
		cooldown = 26000, -- 26s
	},
	mirrorSpawns = {
		id = 213921,
		offset = 1500, -- New mirror appears at 0s, gets initial color at 4s, so do the alert slightly before that
		data = {
			{ 91, SI_COMPASS_EAST_ABBREVIATION, SI_COMPASS_WEST_ABBREVIATION },
			{ 61, SI_COMPASS_NORTH_ABBREVIATION, SI_COMPASS_SOUTH_ABBREVIATION },
		},
	},
	shockwave = 213685,
	whirlwind = {
		id = 221882,
		name = 221885, -- cast ID is misspelled, so alert text should use damage ID
	},

	-- Boss 3
	javelin = 223546,
	stomp = 219797,
	burst = 219799,
	knot = {
		claim = 213410,
		carry = 213477,
		passage = {
			id = 222677,
			[222677] = true, -- Carrier
			[218492] = true, -- Bystanders
		},
	},
	links = {
		[223028] = 1,
		[223029] = 2,
	},
	barrage = {
		cast = 223198,
		damage = 223199,
		loc = 223204,
	},
	rain = {
		id = 222809,
		cover = 219014,
		interval = 26000, -- 26s from start to start / 20s from end to start
		initial = 10000, -- 10s
	},
	flux = {
		start = 214570,
		carry = 214597,
		overloaded = 214745,
		interval = 62500, -- 62.5s
		initial = 16500, -- 16.5s
		maxCarry = 15000, -- 15s
	},
	tempest = {
		start = 215107,
		interval = 32000, -- 32s
		initial = 28000, -- 28s
		active = 9500, -- 9.5s
	},
	xoryn = 219230,
	charge = 214542,
	chain = 219179,
	weakening = 222613,
}

local Vars = {
	mirrorSide = {
		light = false,
		dark = false,
	},
	vuln = { },
	annihilation = { },
	lastSummon = 0,
	currentImmunity = nil,
	nextJump = -1,
	knot = {
		unitId = nil,
		carryEnd = 0,
		duration = 0,
		number = 1,
		lastDrop = 0,
		passage = { },
	},
	flux = {
		state = nil,
		next = 0,
		unitId = nil,
		carryStart = 0,
		carryEnd = 0,
		overloaded = { },
	},
	barrage = { },
	link1 = "",
	platformHealth = nil,
	radianceNext = 0,
	radianceActive = 0,
	rainNext = 0,
	rainActive = 0,
	tempestNext = 0,
	tempestActive = 0,
	tempestStart = 0,
}

local function Identifier( x )
	return Module.ID .. x
end

local function GroupPanelPoll( )
	local currentTime = GetGameTimeMilliseconds()
	local passage = Vars.knot.passage
	local overloaded = Vars.flux.overloaded

	for i = 1, GetGroupSize() do
		local unitTag = GetGroupUnitTagByIndex(i)
		local unitId = LCA.IdentifyGroupUnitTag(unitTag)

		if (unitId) then
			local color, hasPassage, hasOverloaded
			local timers = { }

			if (passage[unitId]) then
				local remaining = passage[unitId] - currentTime
				if (remaining > 0) then
					hasPassage = true
					table.insert(timers, LCA.FormatTime(remaining, LCA.TIME_FORMAT_COMPACT))
				end
			end

			if (overloaded[unitId]) then
				local remaining = overloaded[unitId] - currentTime
				if (remaining > 0) then
					hasOverloaded = true
					table.insert(timers, LCA.FormatTime(remaining, LCA.TIME_FORMAT_COMPACT))
				end
			end

			if (hasPassage and hasOverloaded) then
				color = Vars.settings.colorBoth
			elseif (hasPassage) then
				color = Vars.settings.colorPassage
			elseif (hasOverloaded) then
				color = Vars.settings.colorOverloaded
			end

			CA2.GroupPanelUpdate(unitTag, unitId, color, table.concat(timers, "/"))
		end
	end
end

local function StatusInit_B1( )
	for i = 1, 2 do
		for j = 2, 3 do
			CA2.StatusModifyCell(i, j, {
				text = "",
				alignment = TEXT_ALIGN_RIGHT,
				minWidth = "100%",
				color = (j == 2) and COLOR_L32 or COLOR_D32,
			})
		end
	end
	CA2.StatusSetRowAlpha(2, 0)
end

local function StatusPoll_B1( )
	local currentTime = GetGameTimeMilliseconds()
	local showVuln = false
	for i = 1, 2 do
		local unitTag = "boss" .. i
		local remaining = (Vars.vuln[unitTag] or 0) - currentTime
		if (remaining > 0) then
			showVuln = true
		end
		local alpha = Vars.mirrorSide[Data.boss1Reverse[i]] and Data.boss1DimAlpha[i] or 1

		CA2.StatusModifyCell(1, i + 1, {
			text = string.format("%d%%", zo_floor(LCA.GetUnitHealthPercent(unitTag))),
			alpha = alpha,
		})

		CA2.StatusModifyCell(2, i + 1, {
			text = (remaining > 0) and LCA.FormatTime(remaining, LCA.TIME_FORMAT_SHORT) or "",
			alpha = alpha,
		})
	end

	if (showVuln) then
		CA2.StatusSetRowAlpha(2, 1)
	end
end

local function StatusPoll_Mini( )
	local currentTime = GetGameTimeMilliseconds()

	if (currentTime > Vars.radianceActive) then
		local remaining = Vars.radianceNext - currentTime
		local ratio = LCA.Clamp(remaining / Data.radiance.interval, 0, 1)
		CA2.StatusModifyCell(1, 2, {
			text = LCA.FormatTime(remaining, LCA.TIME_FORMAT_SHORT),
			color = LCA.PackRGBA(LCA.HSLToRGB(ratio / 3, 1, 0.5, 1)),
		})
	else
		CA2.StatusModifyCell(1, 2, {
			text = string.format("%s [%s]", GetString(SI_LCA_ACTIVE), LCA.FormatTime(Vars.radianceActive - currentTime, LCA.TIME_FORMAT_SHORT)),
			color = 0xFFFFFFFF,
		})
	end
end

local function StatusInit_B2( )
	Vars.boss2Spawned = true
	CA2.StatusSetCellText(1, 0, "")
end

local function StatusPoll_B2( )
	if (Vars.currentImmunity) then
		local data = Data.immunity[Vars.currentImmunity]
		CA2.StatusModifyCell(1, 2, {
			text = LCA.GetAbilityName(data[1]),
			color = data[2],
		})
		local immune = GetUnitAttributeVisualizerEffectInfo("boss1", ATTRIBUTE_VISUAL_UNWAVERING_POWER, STAT_MITIGATION, ATTRIBUTE_HEALTH, COMBAT_MECHANIC_FLAGS_HEALTH)
		if (immune and immune > 0) then
			CA2.StatusModifyCell(1, 0, {
				text = LCA.GetLocalizedData(STRINGS["254784612-0-28"]),
				color = 0xFFCC00FF,
			})
		else
			CA2.StatusSetCellText(1, 0, "")
		end
	end

	if (Vars.nextJump > 0) then
		local remaining = Vars.nextJump - GetGameTimeMilliseconds()
		local ratio = LCA.Clamp(remaining / Data.jump.cooldown, 0, 1)
		CA2.StatusModifyCell(2, 2, {
			text = LCA.FormatTime(remaining, LCA.TIME_FORMAT_SHORT),
			color = LCA.PackRGBA(LCA.HSLToRGB(ratio / 3, 1, 0.5, 1)),
		})
	elseif (Vars.nextJump == -1) then
		CA2.StatusSetCellText(2, 2, "")
	else
		CA2.StatusSetRowHidden(2, true)
	end
end

local function StatusInit_B3( )
	for i = 1, 3 do
		CA2.StatusModifyCell(i, 2, {
			alignment = TEXT_ALIGN_RIGHT,
			minWidth = "00s",
		})
		if (i < 3) then
			CA2.StatusSetCellText(i, 0, "")
		end
		if (i > 1) then
			CA2.StatusSetRowAlpha(i, 0)
		end
	end
end

local function StatusPoll_B3( )
	local currentTime = GetGameTimeMilliseconds()

	if (Vars.knot.unitId) then
		local remaining = Vars.knot.carryEnd - currentTime
		local ratio = LCA.Clamp(remaining / Vars.knot.duration, 0, 1)
		local _, name = LCA.IdentifyGroupUnitId(Vars.knot.unitId, true)
		CA2.StatusModifyCell(1, 2, {
			text = LCA.FormatTime(remaining, LCA.TIME_FORMAT_SHORT),
			color = LCA.PackRGBA(LCA.HSLToRGB(ratio / 3, 1, 0.5, 1)),
		})
		CA2.StatusSetCellText(1, 3, name)
	else
		CA2.StatusModifyCell(1, 2, {
			text = string.format("%s [%s]", LCA.GetLocalizedData(STRINGS.noCarrier), LCA.FormatTime(currentTime - Vars.knot.lastDrop, LCA.TIME_FORMAT_SHORT)),
			color = 0xFF0000FF,
		})
		CA2.StatusSetCellText(1, 3, "")
	end

	local cdText = ""
	local passage = Vars.knot.passage
	if (passage.selfId and passage[passage.selfId]) then
		local cdRemaining = passage[passage.selfId] - currentTime
		if (cdRemaining > 0) then
			cdText = string.format("%s: %s", LCA.GetAbilityName(Data.knot.passage.id), LCA.FormatTime(cdRemaining, LCA.TIME_FORMAT_LONG))
		end
	end
	CA2.StatusModifyCell(1, 0, {
		text = cdText,
		color = 0xCC0000FF,
	})

	if (Vars.flux.state) then
		if (Vars.flux.state == 1) then
			CA2.StatusSetCellText(2, 2, "")
			CA2.StatusSetCellText(2, 3, Vars.flux.targetName or "")
		elseif (Vars.flux.state == 2) then
			local carried = currentTime - Vars.flux.carryStart
			local ratio = LCA.Clamp(1 - carried / Data.flux.maxCarry, 0, 1)
			CA2.StatusSetCellText(2, 2, LCA.FormatTime(Vars.flux.carryEnd - currentTime, LCA.TIME_FORMAT_SHORT))
			CA2.StatusSetCellText(2, 3, string.format("%s [|c%06X%s|r]", select(2, LCA.IdentifyGroupUnitId(Vars.flux.unitId, true)), LCA.PackRGB(LCA.HSLToRGB(ratio / 3, 1, 0.5)), LCA.FormatTime(carried, LCA.TIME_FORMAT_SHORT)))
		elseif (Vars.flux.state == 3) then
			CA2.StatusSetCellText(2, 2, LCA.FormatTime(Vars.flux.next - currentTime, LCA.TIME_FORMAT_SHORT))
			CA2.StatusSetCellText(2, 3, LCA.GetLocalizedData(STRINGS.toNext))
		end

		cdText = ""
		local overloaded = Vars.flux.overloaded
		if (overloaded.selfId and overloaded[overloaded.selfId]) then
			local cdRemaining = overloaded[overloaded.selfId] - currentTime
			if (cdRemaining > 0) then
				cdText = string.format("%s: %s", LCA.GetAbilityName(Data.flux.overloaded), LCA.FormatTime(cdRemaining, LCA.TIME_FORMAT_LONG))
			end
		end
		CA2.StatusModifyCell(2, 0, {
			text = cdText,
			color = 0xCC0000FF,
		})

		if (currentTime > Vars.tempestActive) then
			CA2.StatusSetCellText(3, 2, LCA.FormatTime(Vars.tempestNext - currentTime, LCA.TIME_FORMAT_SHORT))
			CA2.StatusSetCellText(3, 3, LCA.GetLocalizedData(STRINGS.toNext))
		else
			local elapsed = currentTime - Vars.tempestStart
			CA2.StatusSetCellText(3, 2, string.format((elapsed < 6500) and "%s [%s]" or "%s [|c0099FF%s|r]", GetString(SI_LCA_ACTIVE), LCA.FormatTime(elapsed, LCA.TIME_FORMAT_SHORT)))
			CA2.StatusSetCellText(3, 3, "")
		end
	else
		-- Crystal health
		local alpha = 0
		if (not Vars.platformHealth and GetUnitName("boss2") ~= "") then
			Vars.platformHealth = select(2, GetUnitPower("boss2", COMBAT_MECHANIC_FLAGS_HEALTH))
		end
		if (Vars.platformHealth) then
			local results = { }
			for i = 1, 4 do
				local current, max, effectiveMax = GetUnitPower("boss" .. i, COMBAT_MECHANIC_FLAGS_HEALTH)
				if (max == Vars.platformHealth) then
					table.insert(results, string.format("%d%%", zo_floor(100 * current / effectiveMax)))
				end
			end
			if (#results > 0) then
				CA2.StatusSetCellText(2, 2, table.concat(results, " / "))
				alpha = 1
			end
		end
		CA2.StatusSetRowAlpha(2, alpha)

		-- Necrotic rain
		alpha = 1
		if (Vars.rainNext == 0) then
			alpha = 0
		elseif (currentTime > Vars.rainActive) then
			CA2.StatusSetCellText(3, 2, LCA.FormatTime(Vars.rainNext - currentTime, LCA.TIME_FORMAT_SHORT))
			CA2.StatusSetCellText(3, 3, LCA.GetLocalizedData(STRINGS.toNext))
		else
			CA2.StatusSetCellText(3, 2, string.format("%s [%s]", GetString(SI_LCA_ACTIVE), LCA.FormatTime(Vars.rainActive - currentTime, LCA.TIME_FORMAT_SHORT)))
			CA2.StatusSetCellText(3, 3, "")
		end
		CA2.StatusSetRowAlpha(3, alpha)
	end

	if (CA2.GroupPanelIsEnabled()) then
		GroupPanelPoll()
	end
end

local function BannerPoll_Annihilation( )
	local remaining = Vars.annihilation.castEnd - GetGameTimeMilliseconds()
	if (remaining < 0) then
		CA1.DisableBanner(Vars.annihilation.bannerId)
		Vars.annihilation.bannerId = nil
	end
	if (Vars.annihilation.bannerId) then
		CA1.ModifyBanner(Vars.annihilation.bannerId, nil, string.format("%s: %s", Vars.annihilation.name, LCA.FormatTime(remaining, LCA.TIME_FORMAT_COUNTDOWN)), 0xFF6633FF)
	end
end

local function BannerPoll_Barrage( )
	local remaining = Vars.barrage.castEnd - GetGameTimeMilliseconds()
	local extraText
	if (Vars.barrage.targetName and remaining > -1500) then
		extraText = Vars.barrage.targetName
	elseif (remaining > -500) then
		extraText = LCA.FormatTime(remaining, LCA.TIME_FORMAT_COUNTDOWN)
	else
		CA1.DisableBanner(Vars.barrage.bannerId)
		Vars.barrage.bannerId = nil
	end
	if (Vars.barrage.bannerId) then
		CA1.ModifyBanner(Vars.barrage.bannerId, nil, string.format("%s: %s", LCA.GetAbilityName(Data.barrage.damage), extraText), 0xCC33CCFF)
	end
end

local function OrbRefresh( )
	CA2.ScreenBorderEnable(0x99FFFFCC, 500, "u42refresh")
	LCA.PlaySounds("DUEL_FORFEIT")
end

local function MirrorSide( _, result, _, _, _, _, _, _, _, _, _, _, _, _, _, _, abilityId )
	if (result == ACTION_RESULT_EFFECT_GAINED_DURATION) then
		if (abilityId == Data.mirrorSide.light) then
			Vars.mirrorSide.light = true
			Vars.mirrorSide.dark = false
		else
			Vars.mirrorSide.light = false
			Vars.mirrorSide.dark = true
		end
	elseif (result == ACTION_RESULT_EFFECT_FADED) then
		if (abilityId == Data.mirrorSide.light) then
			Vars.mirrorSide.light = false
		else
			Vars.mirrorSide.dark = false
		end
	end
end

local function ColorImmunity( _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, abilityId )
	Vars.currentImmunity = abilityId
end

local function StartBoss2Panel( )
	-- There are multiple entry points for this panel:
	-- * Breakout event, but usable only once per instance
	-- * Check boss name at the start of combat, but should not be used prior to Breakout
	-- * Xoryn teleport, as a fail-safe if the others are missed for any reason
	CA2.StatusEnable({
		ownerId = "u42b2",
		rowLabels = { LCA.GetAbilityName(112951), LCA.GetAbilityName(Data.jump.id) },
		pollingFunction = StatusPoll_B2,
		initFunction = StatusInit_B2,
	})
end

local function HandleFluxStart( initial )
	if (not Vars.flux.state) then
		CA2.StatusSetCellText(2, 1, LCA.GetAbilityName(Data.flux.start))
		CA2.StatusSetCellText(3, 1, LCA.GetAbilityName(Data.tempest.start))
		CA2.StatusSetRowAlpha(2, 1)
		CA2.StatusSetRowAlpha(3, 1)
	end
	local currentTime = GetGameTimeMilliseconds()
	if (initial) then
		Vars.flux.state = 3
		Vars.flux.next = currentTime + Data.flux.initial
		Vars.tempestNext = currentTime + Data.tempest.initial
	else
		Vars.flux.state = 1
		Vars.flux.next = currentTime + Data.flux.interval
	end
end

function Module:PostLoad( )
	Vars.boss2Spawned = false

	-- Vulnerability can only be tracked via EVENT_EFFECT_CHANGED

	EVENT_MANAGER:RegisterForEvent(Identifier("MAJ_VULN"), EVENT_EFFECT_CHANGED, function( _, changeType, _, _, unitTag, _, endTime )
		Vars.vuln[unitTag] = (changeType == EFFECT_RESULT_FADED) and 0 or zo_floor(endTime * 1000)
	end)
	EVENT_MANAGER:AddFilterForEvent(Identifier("MAJ_VULN"), EVENT_EFFECT_CHANGED, REGISTER_FILTER_ABILITY_ID, LCA.IDS.MAJ_VULN)
	EVENT_MANAGER:AddFilterForEvent(Identifier("MAJ_VULN"), EVENT_EFFECT_CHANGED, REGISTER_FILTER_UNIT_TAG_PREFIX, "boss")

	-- Events that need to be tracked at all times, even out of combat

	EVENT_MANAGER:RegisterForEvent(Identifier("ORB"), EVENT_COMBAT_EVENT, OrbRefresh)
	EVENT_MANAGER:AddFilterForEvent(Identifier("ORB"), EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, ACTION_RESULT_EFFECT_GAINED_DURATION)
	EVENT_MANAGER:AddFilterForEvent(Identifier("ORB"), EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, Data.refresh)
	EVENT_MANAGER:AddFilterForEvent(Identifier("ORB"), EVENT_COMBAT_EVENT, REGISTER_FILTER_TARGET_COMBAT_UNIT_TYPE, COMBAT_UNIT_TYPE_PLAYER)

	EVENT_MANAGER:RegisterForEvent(Identifier("B1_L"), EVENT_COMBAT_EVENT, MirrorSide)
	EVENT_MANAGER:AddFilterForEvent(Identifier("B1_L"), EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, Data.mirrorSide.light)
	EVENT_MANAGER:AddFilterForEvent(Identifier("B1_L"), EVENT_COMBAT_EVENT, REGISTER_FILTER_TARGET_COMBAT_UNIT_TYPE, COMBAT_UNIT_TYPE_PLAYER)

	EVENT_MANAGER:RegisterForEvent(Identifier("B1_D"), EVENT_COMBAT_EVENT, MirrorSide)
	EVENT_MANAGER:AddFilterForEvent(Identifier("B1_D"), EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, Data.mirrorSide.dark)
	EVENT_MANAGER:AddFilterForEvent(Identifier("B1_D"), EVENT_COMBAT_EVENT, REGISTER_FILTER_TARGET_COMBAT_UNIT_TYPE, COMBAT_UNIT_TYPE_PLAYER)

	EVENT_MANAGER:RegisterForEvent(Identifier("B2_L"), EVENT_COMBAT_EVENT, ColorImmunity)
	EVENT_MANAGER:AddFilterForEvent(Identifier("B2_L"), EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, Data.immunity.light)
	EVENT_MANAGER:AddFilterForEvent(Identifier("B2_L"), EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, ACTION_RESULT_EFFECT_GAINED)

	EVENT_MANAGER:RegisterForEvent(Identifier("B2_D"), EVENT_COMBAT_EVENT, ColorImmunity)
	EVENT_MANAGER:AddFilterForEvent(Identifier("B2_D"), EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, Data.immunity.dark)
	EVENT_MANAGER:AddFilterForEvent(Identifier("B2_D"), EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, ACTION_RESULT_EFFECT_GAINED)

	EVENT_MANAGER:RegisterForEvent(Identifier("B2_START"), EVENT_COMBAT_EVENT, function( )
		StartBoss2Panel()
		self:StartListening()
	end)
	EVENT_MANAGER:AddFilterForEvent(Identifier("B2_START"), EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, ACTION_RESULT_BEGIN)
	EVENT_MANAGER:AddFilterForEvent(Identifier("B2_START"), EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, Data.breakout)

	EVENT_MANAGER:RegisterForEvent(Identifier("B3_START"), EVENT_COMBAT_EVENT, function( )
		local settings = self:GetSettings()
		if (settings.cooldownPanel and LCA.isVet) then
			Vars.settings = settings
			CA2.GroupPanelEnable({
				headerText = string.format("%s / %s", LCA.GetAbilityName(Data.knot.passage.id), LCA.GetAbilityName(Data.flux.overloaded)),
				statWidth = 48,
				useRange = false,
			})
		end
		if (settings.suicidePrevention and LCA.isVet) then
			self:ToggleSplinteredPassageBlock(true)
		end
		self:StartListening()
	end)
	EVENT_MANAGER:AddFilterForEvent(Identifier("B3_START"), EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, ACTION_RESULT_EFFECT_GAINED_DURATION)
	EVENT_MANAGER:AddFilterForEvent(Identifier("B3_START"), EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, Data.knot.claim)
end

function Module:PreUnload( )
	EVENT_MANAGER:UnregisterForEvent(Identifier("MAJ_VULN"), EVENT_EFFECT_CHANGED)
	EVENT_MANAGER:UnregisterForEvent(Identifier("ORB"), EVENT_COMBAT_EVENT)
	EVENT_MANAGER:UnregisterForEvent(Identifier("B1_L"), EVENT_COMBAT_EVENT)
	EVENT_MANAGER:UnregisterForEvent(Identifier("B1_D"), EVENT_COMBAT_EVENT)
	EVENT_MANAGER:UnregisterForEvent(Identifier("B2_L"), EVENT_COMBAT_EVENT)
	EVENT_MANAGER:UnregisterForEvent(Identifier("B2_D"), EVENT_COMBAT_EVENT)
	EVENT_MANAGER:UnregisterForEvent(Identifier("B2_START"), EVENT_COMBAT_EVENT)
	EVENT_MANAGER:UnregisterForEvent(Identifier("B3_START"), EVENT_COMBAT_EVENT)
end

function Module:PreStartListening( )
	Vars.nextJump = -1
	Vars.knot.number = 1
	Vars.knot.passage = { }
	Vars.flux.overloaded = { }
	Vars.flux.state = nil
	Vars.platformHealth = nil
	Vars.rainNext = 0
	if (Vars.boss2Spawned and LCA.MatchStrings(GetUnitName("boss1"), LCA.GetLocalizedData(STRINGS["8290981-0-121169"]))) then
		StartBoss2Panel()
	end
end

function Module:PostStopListening( )
	CA2.StatusDisable()
	CA2.GroupPanelDisable()
	self:ToggleSplinteredPassageBlock(false)
	if (Vars.callLaterId) then
		zo_removeCallLater(Vars.callLaterId)
		Vars.callLaterId = nil
	end
end

function Module:ProcessCombatEvents( result, isError, abilityName, abilityGraphic, abilityActionSlotType, sourceName, sourceType, targetName, targetType, hitValue, powerType, damageType, log, sourceUnitId, targetUnitId, abilityId, overflow )
	-- General
	if (result == ACTION_RESULT_EFFECT_GAINED_DURATION and targetType == COMBAT_UNIT_TYPE_PLAYER and abilityId == Data.darkness) then
		CA1.Alert(nil, LCA.GetAbilityName(abilityId), 0xCC3333FF, SOUNDS.CHAMPION_POINTS_COMMITTED, 1500)
	elseif (result == ACTION_RESULT_BEGIN and abilityId == Data.sunburst.id and targetType == COMBAT_UNIT_TYPE_PLAYER and self:GetSettings().extraAlerts) then
		CA1.Alert(nil, LCA.GetAbilityName(abilityId), 0xFF6600FF, SOUNDS.CHAMPION_POINTS_COMMITTED, 1500)
		CA1.AlertCast(Data.sunburst.damage, sourceName, hitValue + 800, { -3, 0, false, { 1, 0.4, 0, 0.5 } })
	elseif (result == ACTION_RESULT_BEGIN and Data.aoeCleave[abilityId] and not LCA.isTank and self:GetSettings().extraAlerts) then
		CA1.Alert(nil, LCA.GetAbilityName(abilityId), 0xFFFFCCFF, nil, 2000)
		LCA.PlaySounds("DUEL_BOUNDARY_WARNING", 2, 100, "DUEL_BOUNDARY_WARNING", 4)

	-- Boss 1
	elseif (result == ACTION_RESULT_BEGIN and Data.boss1Abilities[abilityId] and GetUnitName("boss2") ~= "") then
		CA2.StatusEnable({
			ownerId = "u42b1",
			rowLabels = { GetString("SI_ATTRIBUTES", ATTRIBUTE_HEALTH), LCA.GetLocalizedData(STRINGS.majVuln) },
			pollingFunction = StatusPoll_B1,
			initFunction = StatusInit_B1,
		})
	elseif (result == ACTION_RESULT_BEGIN and Data.annihilation[abilityId]) then
		if (Vars.mirrorSide[Data.annihilation[abilityId]]) then
			local currentTime = GetGameTimeMilliseconds()
			if (hitValue <= 2000) then
				-- Project full duration during initial windup
				Vars.annihilation.castEnd = currentTime + Data.annihilation.duration
			else
				Vars.annihilation.castEnd = currentTime + hitValue
			end
			Vars.annihilation.name = LCA.GetAbilityName(abilityId)
			if (not Vars.annihilation.bannerId) then
				Vars.annihilation.bannerId = CA1.AlertBannerEx(nil, nil, nil, nil, true, SOUNDS.CHAMPION_POINTS_COMMITTED, BannerPoll_Annihilation)
			end
		end
	elseif (result == ACTION_RESULT_EFFECT_GAINED_DURATION and targetType == COMBAT_UNIT_TYPE_PLAYER and Data.luster[abilityId] and not LCA.isTank and self:GetSettings().extraAlerts) then
		CA1.Alert(nil, LCA.GetAbilityName(abilityId), Data.luster[abilityId], SOUNDS.CHAMPION_POINTS_COMMITTED, 1500)
	elseif (result == ACTION_RESULT_EFFECT_GAINED and Data.summons[abilityId] and LCA.DoesPlayerHaveTauntOrPullSlotted()) then
		local currentTime = GetGameTimeMilliseconds()
		local data = Data.summons[abilityId]
		if (Vars.mirrorSide[data.side] and data.tank == LCA.isTank and currentTime - Vars.lastSummon > 2000) then
			Vars.lastSummon = currentTime
			CA1.Alert(LCA.GetAbilityName(abilityId), zo_strformat(SI_INTERACT_PROMPT_FORMAT_UNIT_NAME, data.name), data.color, SOUNDS.CHAMPION_POINTS_COMMITTED, 2500)
		end
	elseif (LCA.isVet and result == ACTION_RESULT_BEGIN and Data.shear[abilityId] and targetType ~= COMBAT_UNIT_TYPE_PLAYER and not LCA.isTank and self:GetSettings().extraAlerts) then
		if (Vars.mirrorSide.light or CA2.StatusGetOwnerId() ~= "u42b1") then
			CA1.Alert(nil, LCA.GetAbilityName(Data.meteor), 0x00FFFFFF, SOUNDS.CHAMPION_POINTS_COMMITTED, 2000)
		end

	-- Miniboss
	elseif (result == ACTION_RESULT_BEGIN and abilityId == Data.radiance.id) then
		Vars.radianceActive = GetGameTimeMilliseconds() + hitValue
		if (hitValue <= 2000) then
			-- Project full duration during initial windup
			Vars.radianceActive = Vars.radianceActive + Data.radiance.duration
		end
		Vars.radianceNext = Vars.radianceActive + Data.radiance.interval
		CA2.StatusEnable({
			ownerId = "u42mini",
			rowLabels = LCA.GetAbilityName(abilityId),
			pollingFunction = StatusPoll_Mini,
		})

	-- Boss 2
	elseif (result == ACTION_RESULT_BEGIN and abilityId == Data.fateSealer and (targetType == COMBAT_UNIT_TYPE_PLAYER or LCA.DoesPlayerHaveTauntSlotted() or self:GetSettings().raidLeadMode)) then
		CA1.Alert(nil, LCA.GetAbilityName(abilityId), 0xFF6633FF, nil, 2500)
		if (targetType == COMBAT_UNIT_TYPE_PLAYER) then
			-- Play a sound only for the MT
			LCA.PlaySounds("DUEL_BOUNDARY_WARNING", 3, 750, "DUEL_BOUNDARY_WARNING", 3, 750, "DUEL_BOUNDARY_WARNING", 4)
		end
	elseif (result == ACTION_RESULT_BEGIN and abilityId == Data.jump.id) then
		local unitTag, name = LCA.IdentifyGroupUnitId(targetUnitId)
		if (unitTag) then
			Vars.nextJump = GetGameTimeMilliseconds() + Data.jump.cooldown
			if (targetType == COMBAT_UNIT_TYPE_PLAYER or LCA.GetDistance("player", unitTag) < 6) then
				CA1.Alert(LCA.GetAbilityName(abilityId), name, 0xCC3399FF, SOUNDS.CHAMPION_POINTS_COMMITTED, 2000)
			end
			StartBoss2Panel()
		end
	elseif (result == ACTION_RESULT_BEGIN and Data.jump.escape[abilityId]) then
		-- Hide timer when Xoryn leaves
		Vars.nextJump = Data.jump.escape[abilityId]
	elseif (LCA.isVet and result == ACTION_RESULT_EFFECT_FADED and abilityId == Data.mirrorSpawns.id and self:GetSettings().mirrorSpawns) then
		local health = LCA.GetUnitHealthPercent("boss1")
		for _, spawn in ipairs(Data.mirrorSpawns.data) do
			if (spawn[1] > health and spawn[1] - health < 15) then
				Vars.callLaterId = zo_callLater(function( )
					CA1.Alert(nil, string.format("%s — %s & %s", LCA.GetLocalizedData(STRINGS.newMirrors), GetString(spawn[2]), GetString(spawn[3])), 0xFF00FFFF, SOUNDS.CHAMPION_POINTS_COMMITTED, 2000)
				end, Data.mirrorSpawns.offset)
			end
		end
	elseif (LCA.isVet and result == ACTION_RESULT_BEGIN and abilityId == Data.shockwave and not LCA.isTank and self:GetSettings().extraAlerts) then
		Vars.callLaterId = zo_callLater(function( )
			CA1.Alert(nil, LCA.GetAbilityName(abilityId), 0x66CCFFFF, SOUNDS.CHAMPION_POINTS_COMMITTED, 2000)
		end, 1500)
	elseif (result == ACTION_RESULT_BEGIN and abilityId == Data.whirlwind.id and not LCA.isTank and self:GetSettings().whirlwind) then
		CA1.Alert(nil, LCA.GetAbilityName(Data.whirlwind.name), 0xFFFFCCFF, nil, 2000)
		LCA.PlaySounds("DUEL_BOUNDARY_WARNING", 2, 100, "DUEL_BOUNDARY_WARNING", 4)

	-- Boss 3
	elseif (result == ACTION_RESULT_BEGIN and abilityId == Data.javelin and targetType == COMBAT_UNIT_TYPE_PLAYER and not LCA.isTank) then
		LCA.PlaySounds("DUEL_START")
	elseif (result == ACTION_RESULT_BEGIN and abilityId == Data.stomp and targetType == COMBAT_UNIT_TYPE_PLAYER) then
		CA1.AlertCast(Data.burst, sourceName, hitValue, { -2, 2, false, { 0.3, 0.9, 1, 0.6 }, { 0, 0.5, 1, 1 } })
	elseif (abilityId == Data.knot.carry) then
		local knotName = LCA.GetAbilityName(Data.knot.carry)
		if (result == ACTION_RESULT_EFFECT_GAINED_DURATION) then
			Vars.knot.unitId = targetUnitId
			Vars.knot.carryEnd = GetGameTimeMilliseconds() + hitValue
			Vars.knot.duration = hitValue
			CA2.StatusEnable({
				ownerId = "u42b3",
				rowLabels = { knotName, GetString("SI_ATTRIBUTES", ATTRIBUTE_HEALTH), LCA.GetAbilityName(Data.rain.id) },
				pollingFunction = StatusPoll_B3,
				initFunction = StatusInit_B3,
			})
		elseif (result == ACTION_RESULT_EFFECT_FADED) then
			Vars.knot.unitId = nil
			Vars.knot.number = Vars.knot.number + 1
			Vars.knot.lastDrop = GetGameTimeMilliseconds()
		end
		if (result ~= ACTION_RESULT_EFFECT_GAINED) then
			if (self:GetSettings().knotNumber) then
				CA2.StatusSetCellText(1, 1, string.format("%s #%d", knotName, Vars.knot.number))
			else
				CA2.StatusSetCellText(1, 1, knotName)
			end
		end
	elseif (Data.knot.passage[abilityId]) then
		local passage = Vars.knot.passage
		if (result == ACTION_RESULT_EFFECT_GAINED_DURATION) then
			passage[targetUnitId] = GetGameTimeMilliseconds() + hitValue
		elseif (result == ACTION_RESULT_EFFECT_FADED) then
			passage[targetUnitId] = nil
		end
		if (targetType == COMBAT_UNIT_TYPE_PLAYER) then
			passage.selfId = targetUnitId
		end
	elseif (result == ACTION_RESULT_EFFECT_GAINED and Data.links[abilityId]) then
		local _, name = LCA.IdentifyGroupUnitId(targetUnitId, true)
		if (Data.links[abilityId] == 1) then
			Vars.link1 = name
		else
			CA1.Alert(LCA.GetAbilityName(abilityId), string.format("%s / %s", Vars.link1, name), 0xCC3399FF, SOUNDS.CHAMPION_POINTS_COMMITTED, 3500)
			Vars.link1 = ""
		end
	elseif (result == ACTION_RESULT_BEGIN and abilityId == Data.barrage.cast) then
		Vars.barrage.castEnd = GetGameTimeMilliseconds() + hitValue
		Vars.barrage.targetName = nil
		Vars.barrage.bannerId = CA1.AlertBannerEx(nil, nil, nil, nil, true, SOUNDS.CHAMPION_POINTS_COMMITTED, BannerPoll_Barrage)
	elseif (result == ACTION_RESULT_EFFECT_GAINED and abilityId == Data.barrage.loc) then
		Vars.barrage.targetName = select(2, LCA.IdentifyGroupUnitId(targetUnitId, true))
		if (targetType == COMBAT_UNIT_TYPE_PLAYER) then
			LCA.PlaySounds("FRIEND_INVITE_RECEIVED", 2, 150, "DUEL_BOUNDARY_WARNING", 4)
		end
	elseif (abilityId == Data.rain.cover) then
		if (result == ACTION_RESULT_EFFECT_GAINED_DURATION) then
			Vars.rainNext = GetGameTimeMilliseconds() + Data.rain.initial
		elseif (result == ACTION_RESULT_EFFECT_FADED) then
			Vars.rainNext = 0
		end
	elseif (result == ACTION_RESULT_BEGIN and abilityId == Data.rain.id and hitValue >= 1000) then
		local currentTime = GetGameTimeMilliseconds()
		Vars.rainNext = currentTime + Data.rain.interval
		Vars.rainActive = currentTime + hitValue
	elseif (result == ACTION_RESULT_EFFECT_GAINED_DURATION and abilityId == Data.xoryn) then
		HandleFluxStart(true)
	elseif (result == ACTION_RESULT_BEGIN and abilityId == Data.flux.start) then
		Vars.flux.targetName = select(2, LCA.IdentifyGroupUnitId(targetUnitId, true))
		CA1.Alert(LCA.GetAbilityName(abilityId), Vars.flux.targetName, 0x00CC99FF, SOUNDS.CHAMPION_POINTS_COMMITTED, 2000)
		HandleFluxStart()
	elseif (abilityId == Data.flux.carry) then
		if (result == ACTION_RESULT_EFFECT_GAINED_DURATION) then
			local currentTime = GetGameTimeMilliseconds()
			Vars.flux.state = 2
			Vars.flux.unitId = targetUnitId
			Vars.flux.carryStart = currentTime
			Vars.flux.carryEnd = currentTime + hitValue
		elseif (result == ACTION_RESULT_EFFECT_FADED and Vars.flux.unitId == targetUnitId) then
			Vars.flux.state = 3
			Vars.flux.unitId = nil
		end
	elseif (abilityId == Data.flux.overloaded) then
		local overloaded = Vars.flux.overloaded
		if (result == ACTION_RESULT_EFFECT_GAINED_DURATION) then
			overloaded[targetUnitId] = GetGameTimeMilliseconds() + hitValue
		elseif (result == ACTION_RESULT_EFFECT_FADED) then
			overloaded[targetUnitId] = nil
		end
		if (targetType == COMBAT_UNIT_TYPE_PLAYER) then
			overloaded.selfId = targetUnitId
		end
	elseif (result == ACTION_RESULT_BEGIN and abilityId == Data.tempest.start) then
		local currentTime = GetGameTimeMilliseconds()
		Vars.tempestNext = currentTime + Data.tempest.interval
		Vars.tempestActive = currentTime + Data.tempest.active
		Vars.tempestStart = currentTime
		CA1.Alert(nil, LCA.GetAbilityName(abilityId), 0x66CCFFFF, SOUNDS.CHAMPION_POINTS_COMMITTED, 2000)
	elseif (result == ACTION_RESULT_BEGIN and abilityId == Data.charge and hitValue > 1000 and targetType ~= COMBAT_UNIT_TYPE_PLAYER and not LCA.isTank and self:GetSettings().extraAlerts) then
		Vars.callLaterId = zo_callLater(function( )
			CA1.Alert(nil, LCA.GetAbilityName(Data.chain), 0x00FFFFFF, nil, 3250)
			LCA.PlaySounds("DUEL_BOUNDARY_WARNING", 3, 300, "DUEL_BOUNDARY_WARNING", 3)
		end, 2250)
	elseif (result == ACTION_RESULT_EFFECT_GAINED_DURATION and abilityId == Data.weakening and (targetType == COMBAT_UNIT_TYPE_PLAYER or LCA.DoesPlayerHaveTauntSlotted() or self:GetSettings().raidLeadMode)) then
		local _, name = LCA.IdentifyGroupUnitId(targetUnitId, true)
		CA1.Alert(LCA.GetAbilityName(abilityId), name, 0xCC3399FF, SOUNDS.CHAMPION_POINTS_COMMITTED, 2000)
	end
end

do
	local action = LCA.GetLocalizedData(STRINGS["74865733-0-34170"])
	local name = LCA.GetLocalizedData(STRINGS["87370069-0-34170"])

	local shouldBlock = function( )
		local passage = Vars.knot.passage
		if (passage.selfId and passage[passage.selfId]) then
			return passage[passage.selfId] > GetGameTimeMilliseconds()
		end
	end

	function Module:ToggleSplinteredPassageBlock( enable )
		if (enable) then
			LCA.RegisterInteractionBlock(self.ID, action, name, shouldBlock)
		else
			LCA.RegisterInteractionBlock(self.ID)
		end
	end
end

function Module:GetSettingsControls( )
	local settings = self:GetSettings()

	local extraAlertsTooltipNames = { }
	for _, abilityId in ipairs(Data.extraAlertsTooltipIds) do
		table.insert(extraAlertsTooltipNames, LCA.GetAbilityName(abilityId))
	end

	local cooldownPanelDisabled = function() return not settings.cooldownPanel end

	return {
		--------------------
		{
			type = "checkbox",
			name = SI_CA_SETTINGS_MODULE_RAID_LEAD,
			tooltip = SI_CA_SETTINGS_MODULE_RAID_LEAD_TT,
			getFunc = function() return settings.raidLeadMode end,
			setFunc = function(enabled) settings.raidLeadMode = enabled end,
		},
		--------------------
		{
			type = "checkbox",
			name = LCA.GetLocalizedData(STRINGS.mirrorSpawns),
			getFunc = function() return settings.mirrorSpawns end,
			setFunc = function(enabled) settings.mirrorSpawns = enabled end,
		},
		--------------------
		{
			type = "checkbox",
			name = zo_strformat(SI_CA_SETTINGS_MODULE_ALERT_TEMPLATE, LCA.GetAbilityName(Data.whirlwind.id)),
			getFunc = function() return settings.whirlwind end,
			setFunc = function(enabled) settings.whirlwind = enabled end,
		},
		--------------------
		{
			type = "checkbox",
			name = LCA.GetLocalizedData(STRINGS.extraAlerts),
			tooltip = table.concat(extraAlertsTooltipNames, "\n"),
			getFunc = function() return settings.extraAlerts end,
			setFunc = function(enabled) settings.extraAlerts = enabled end,
		},
		--------------------
		{
			type = "checkbox",
			name = LCA.GetLocalizedData(STRINGS.knotNumber),
			getFunc = function() return settings.knotNumber end,
			setFunc = function(enabled) settings.knotNumber = enabled end,
		},
		--------------------
		{
			type = "checkbox",
			name = LCA.GetLocalizedData(STRINGS.cooldownPanel),
			getFunc = function() return settings.cooldownPanel end,
			setFunc = function(enabled) settings.cooldownPanel = enabled end,
		},
		--------------------
		{
			type = "colorpicker",
			name = string.format("|u40:0::%s|u", LCA.GetAbilityName(Data.knot.passage.id)),
			getFunc = function() return LCA.UnpackRGBA(settings.colorPassage) end,
			setFunc = function(...) settings.colorPassage = LCA.PackRGBA(...) end,
			disabled = cooldownPanelDisabled,
		},
		--------------------
		{
			type = "colorpicker",
			name = string.format("|u40:0::%s|u", LCA.GetAbilityName(Data.flux.overloaded)),
			getFunc = function() return LCA.UnpackRGBA(settings.colorOverloaded) end,
			setFunc = function(...) settings.colorOverloaded = LCA.PackRGBA(...) end,
			disabled = cooldownPanelDisabled,
		},
		--------------------
		{
			type = "colorpicker",
			name = string.format("|u40:0::%s & %s|u", LCA.GetAbilityName(Data.knot.passage.id), LCA.GetAbilityName(Data.flux.overloaded)),
			getFunc = function() return LCA.UnpackRGBA(settings.colorBoth) end,
			setFunc = function(...) settings.colorBoth = LCA.PackRGBA(...) end,
			disabled = cooldownPanelDisabled,
		},
		--------------------
		{
			type = "checkbox",
			name = LCA.GetLocalizedData(STRINGS.suicidePrevention),
			getFunc = function() return settings.suicidePrevention end,
			setFunc = function(enabled) settings.suicidePrevention = enabled end,
		},
	}
end

function Module:GetDebugData( )
	return Vars
end

CA2.RegisterModule(Module)
